diff --git a/libgui/src/property-inspector-table.cc b/libgui/src/property-inspector-table.cc
new file mode 100644
--- /dev/null
+++ b/libgui/src/property-inspector-table.cc
@@ -0,0 +1,1725 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <algorithm>
+#include <limits>
+#include <sstream>
+#include <vector>
+
+#include <QApplication>
+#include <QButtonGroup>
+#include <QColorDialog>
+#include <QComboBox>
+#include <QDataStream>
+#include <QDebug>
+#include <QGridLayout>
+#include <QHeaderView>
+#include <QPainter>
+#include <QStyle>
+#include <QTableView>
+
+#include "caseless-str.h"
+
+#include "graphics.h"
+#include "interpreter.h"
+
+#include "gui-preferences-pi.h"
+#include "gui-settings.h"
+#include "item-hyperlink-delegate.h"
+#include "octave-qobject.h"
+#include "property-inspector-table.h"
+#include "qt-application.h"
+#include "ui-property-inspector-color-editor.h"
+
+namespace octave
+{
+
+  enum Column
+  {
+    // COL_NAME,
+    COL_VALUE,
+    COL_TYPE,
+    COL_DOCLINK,
+
+    COL_COUNT,
+  };
+
+  // max number of displayed items
+  constexpr int array_disp_limit = 4;
+  // max number of items to allow edition
+  // (TODO: forward to variable editor for bigger data)
+  constexpr int matrix_edit_row_limit = 4;
+  constexpr int matrix_edit_col_limit = 4;
+
+  go_properties_table_view::go_properties_table_view (QWidget *parent)
+      : QTableView (parent)
+  {
+    setMouseTracking (true);
+  }
+
+  go_properties_table_view::~go_properties_table_view () = default;
+
+  void go_properties_table_view::mouseMoveEvent (QMouseEvent *ev)
+  {
+    if (m_hl_dg)
+      {
+        m_hl_dg->mouse_move_event (ev);
+      }
+    QTableView::mouseMoveEvent (ev);
+  }
+
+  void go_properties_table_view::mousePressEvent (QMouseEvent *ev)
+  {
+    if (m_hl_dg && m_hl_dg->mouse_press_event (ev))
+      {
+        ev->accept ();
+        return;
+      }
+    QTableView::mousePressEvent (ev);
+  }
+
+  void go_properties_table_view::mouseReleaseEvent (QMouseEvent *ev)
+  {
+    if (m_hl_dg)
+      {
+        m_hl_dg->mouse_release_event (ev);
+      }
+    QTableView::mouseReleaseEvent (ev);
+  }
+
+  //! turn "figure" or "FIGURE" into "Figure"
+  inline QString titlecased (const QString &input)
+  {
+    if (input.size () <= 1)
+      return input;
+    return input[0].toUpper () + input.right (input.size () - 1).toLower ();
+  }
+
+  inline QUrl go_property_doc_url (const QString &obj_type,
+                                   const QString &prop_name,
+                                   const QString &octave_version = "latest")
+  {
+    return QUrl (
+        QString ("https://octave.org/doc/%1/%2-Properties.html#XREF%3%4")
+            .arg (octave_version, titlecased (obj_type), obj_type.toLower (),
+                  prop_name.toLower ()));
+  }
+
+  template <class prop_type>
+  inline QString property_string_value (const base_property *prop)
+  {
+    const auto *p = static_cast<const prop_type *> (prop);
+    return QString::fromStdString (p->string_value ());
+  }
+
+  static QString function_display_text (octave_function *of)
+  {
+    if (of->is_user_function () && of->is_anonymous_function ())
+      {
+        const auto uf = of->user_function_value ();
+        return QString ("(anonymous at %1:%2)")
+            .arg (QString::fromStdString (uf->src_file_name ()),
+                  QString::number (uf->beginning_line ()));
+      }
+
+    return QString ("(%1)").arg (
+        QString::fromStdString (of->canonical_name ()));
+  }
+
+  static bool specific_matrix_item (const base_property *prop)
+  {
+    if (prop->prop_type () == PROP_COLOR)
+      {
+        // color have matrix values but deserve special treatment
+        return false;
+      }
+
+    auto val = prop->get ();
+
+    if (val.is_char_matrix ())
+      return false;
+    if (!val.is_real_matrix ())
+      return false;
+
+    if (val.ndims () != 2)
+      return false;
+
+    const auto matrix = val.matrix_value ();
+
+    return matrix.numel () > 1 && matrix.rows () <= matrix_edit_row_limit
+           && matrix.cols () <= matrix_edit_col_limit;
+  }
+
+  static QString array_display_string (const Matrix &m,
+                                       int lim = array_disp_limit)
+  {
+    const auto dims = m.dims ();
+    if (dims.ndims () == 0)
+      return "[]";
+    if (dims.ndims () == 1)
+      {
+        return "[...]"; // can't be
+      }
+    int count = 0;
+    QStringList rows;
+    for (int r = 0; r < dims.elem (0); ++r)
+      {
+        QStringList cols;
+        for (int c = 0; c < dims.elem (1); ++c)
+          {
+            // to avoid confusion between "," column separator
+            // and "," decimal separator on some locales, we use explicit
+            // C locale conversion (what QString::number does)
+            cols.push_back (QString::number (m (r, c)));
+            if (++count >= lim)
+              {
+                break;
+              }
+          }
+        if (cols.size ())
+          {
+            rows.push_back (cols.join (" , "));
+          }
+        if (count >= lim)
+          break;
+      }
+    QString data = rows.join (" ; ");
+    QString closing = dims.numel () > lim ? "..." : "]";
+    return QString ("[ %1 %2").arg (data, closing);
+  }
+
+  static QVariant property_display_data (const base_property *prop,
+                                         base_qobject &oct_qobj)
+  {
+    // some types require special handling, the other are checked from
+    // the octave_value
+    switch (prop->prop_type ())
+      {
+      case PROP_HANDLE:
+        {
+          const auto *p = static_cast<const handle_property *> (prop);
+          auto gh = p->handle_value ();
+
+          auto gh_mgr = oct_qobj.interpreter_qobj ()->get_gh_manager ();
+          auto obj = gh_mgr->get_object (gh);
+
+          if (!obj)
+            return "(undefined)";
+
+          return QString ("%1 (%2 handle)")
+              .arg (QString::number (gh.value ()),
+                    QString::fromStdString (obj.type ()));
+        }
+      case PROP_CALLBACK:
+        {
+          auto val = prop->get ();
+          if (!val.is_defined () || val.isempty ())
+            {
+              return "(undefined)";
+            }
+          // handling through regular value
+          break;
+        }
+      default:
+        break;
+      }
+
+    auto value = prop->get ();
+    if (!value.is_defined ())
+      {
+        return "(undefined)";
+      }
+    if (value.is_string ())
+      {
+        return QString::fromStdString (value.string_value ());
+      }
+    if (value.is_real_scalar ())
+      {
+        return value.scalar_value ();
+      }
+    if (value.is_function ())
+      {
+        return function_display_text (value.function_value ());
+      }
+    if (value.is_real_matrix ())
+      {
+        return array_display_string (value.matrix_value ());
+      }
+
+    return "";
+  }
+
+  static QString dims_string (const dim_vector &dv)
+  {
+    QStringList dims;
+    for (int i = 0; i < dv.ndims (); ++i)
+      {
+        dims.push_back (QString::number (dv.elem (i)));
+      }
+    return dims.join ('x');
+  }
+
+  static QString property_type_string (base_property *prop)
+  {
+    if (!prop)
+      return "(null)";
+
+    switch (prop->prop_type ())
+      {
+      case PROP_INVALID:
+        return "invalid";
+      case PROP_ROW_VECTOR:
+      case PROP_ARRAY:
+        return QString ("%1 matrix").arg (dims_string (prop->get ().dims ()));
+      case PROP_BOOL:
+        return "boolean";
+      case PROP_CALLBACK:
+        return "callback";
+      case PROP_CHILDREN:
+        return "children";
+      case PROP_COLOR:
+        return "color";
+      case PROP_DOUBLE:
+        return "double";
+      case PROP_DOUBLE_RADIO:
+        return "double radio";
+      case PROP_HANDLE:
+        return "handle";
+      case PROP_RADIO:
+        return "radio";
+      case PROP_STRING:
+        return "string";
+      case PROP_STRING_ARRAY:
+        return "string array";
+      case PROP_TEXT_LABEL:
+        return "text label";
+      case PROP_ANY:
+        return "any";
+      }
+    return "";
+  }
+
+  static bool property_editable (const base_property *prop)
+  {
+    if (!prop)
+      return false;
+
+    const auto value = prop->get ();
+
+    switch (prop->prop_type ())
+      {
+      case PROP_INVALID:
+      case PROP_STRING_ARRAY:
+      case PROP_DOUBLE_RADIO:
+      case PROP_CHILDREN:
+      case PROP_HANDLE:
+      case PROP_CALLBACK:
+      case PROP_ANY:
+        return false;
+      default:
+        break;
+      }
+
+    if (prop->prop_type () == PROP_COLOR)
+      return true;
+
+    return prop->is_radio () || value.is_string () || value.is_real_scalar ()
+           || specific_matrix_item (prop);
+  }
+
+  go_properties_table_model::go_properties_table_model (
+      QObject *p, base_qobject &oct_qobj, const graphics_object &go)
+      : QAbstractTableModel (p), m_oct_qobj{ oct_qobj }, m_go{ go }
+  {
+    if (!go)
+      return;
+
+    const auto name_set = go.get_properties ().all_property_names ();
+
+    static const auto parent = caseless_str ("parent");
+    static const auto children = caseless_str ("children");
+
+    for (const auto &name : name_set)
+      {
+        if (parent.compare (name) || children.compare (name))
+          continue;
+
+        if (name.size () > 1 && name[0] == '_' && name[1] == '_')
+          continue;
+
+        const auto prop = m_go.get_properties ().get_property (name);
+
+        if (prop.is_hidden ())
+          continue;
+
+        prop_index pi;
+        pi.name = name;
+        pi.id = prop.get_id ();
+        m_props.push_back (pi);
+      }
+    std::sort (m_props.begin (), m_props.end (),
+               [] (const prop_index &a, const prop_index &b) -> bool {
+                 return a.name < b.name;
+               });
+
+    auto events = m_oct_qobj.get_qt_interpreter_events ();
+
+    QObject::connect (events.get (), &qt_interpreter_events::go_updated, this,
+                      &go_properties_table_model::handle_go_update);
+  }
+
+  go_properties_table_model::~go_properties_table_model () {}
+
+  int go_properties_table_model::columnCount (const QModelIndex &) const
+  {
+    return COL_COUNT;
+  }
+
+  int go_properties_table_model::rowCount (const QModelIndex &) const
+  {
+    return static_cast<int> (m_props.size ());
+  }
+
+  QVariant go_properties_table_model::headerData (int section,
+                                                  Qt::Orientation orientation,
+                                                  int role) const
+  {
+    if (orientation == Qt::Vertical)
+      {
+        switch (role)
+          {
+          case Qt::DisplayRole:
+            {
+              if (section < 0 || section > static_cast<int> (m_props.size ()))
+                return QVariant{};
+              return QString::fromStdString (m_props[section].name);
+            }
+          case Qt::TextAlignmentRole:
+            return QVariant (Qt::AlignLeft | Qt::AlignVCenter);
+          }
+      }
+    else
+      {
+        switch (role)
+          {
+          case Qt::DisplayRole:
+            switch (section)
+              {
+              // case COL_NAME:
+              //   return tr ("Name");
+              case COL_VALUE:
+                return tr ("Value");
+              case COL_TYPE:
+                return tr ("Type");
+              case COL_DOCLINK:
+                return tr ("Doc");
+              default:
+                return QVariant{};
+              }
+          case Qt::TextAlignmentRole:
+            switch (section)
+              {
+              case COL_DOCLINK:
+                return QVariant (Qt::AlignCenter);
+              // case COL_NAME:
+              case COL_VALUE:
+              case COL_TYPE:
+              default:
+                return QVariant (Qt::AlignVCenter | Qt::AlignLeft);
+              }
+          }
+      }
+
+    return QVariant{};
+  }
+
+  QModelIndex go_properties_table_model::index (int row, int column,
+                                                const QModelIndex &) const
+  {
+    // we place the pointer to the base_property in the index
+    // this is safe because the model keep a reference to the graphics object
+    if (row < 0 || row >= static_cast<int> (m_props.size ()))
+      return QModelIndex{};
+
+    graphics_object go = m_go; // remove constness
+
+    const auto &prop_name = m_props[row].name;
+    base_property &prop
+        = go.get_properties ().get_property (prop_name).as_base_property ();
+
+    return createIndex (row, column, &prop);
+  }
+
+  Qt::ItemFlags
+  go_properties_table_model::flags (const QModelIndex &index) const
+  {
+    auto f = QAbstractTableModel::flags (index);
+    if (index.column () == COL_VALUE)
+      {
+        const auto *prop
+            = static_cast<base_property *> (index.internalPointer ());
+
+        f.setFlag (Qt::ItemIsEditable, property_editable (prop));
+      }
+    return f;
+  }
+
+  QVariant go_properties_table_model::data (const QModelIndex &index,
+                                            int role) const
+  {
+    auto *prop = static_cast<base_property *> (index.internalPointer ());
+    if (!prop)
+      return QVariant{};
+
+    if (index.row () < 0 || index.row () >= static_cast<int> (m_props.size ()))
+      return QVariant{};
+
+    if (index.column () == COL_VALUE && role == Qt::TextColorRole)
+      {
+        if (!prop->get ().is_defined ())
+          {
+            return QColor (Qt::gray);
+          }
+      }
+
+    if (role == Qt::TextAlignmentRole)
+      {
+        switch (index.column ())
+          {
+          // case COL_NAME:
+          //   return QVariant (Qt::AlignVCenter | Qt::AlignLeft);
+          case COL_VALUE:
+            return QVariant (Qt::AlignVCenter | Qt::AlignLeft);
+          case COL_TYPE:
+            return QVariant (Qt::AlignVCenter | Qt::AlignLeft);
+          case COL_DOCLINK:
+            return QVariant (Qt::AlignCenter);
+          default:
+            return QVariant{};
+          }
+      }
+
+    if (role == Qt::ToolTipRole && index.column () == COL_DOCLINK)
+      return go_property_doc_url (QString::fromStdString (m_go.type ()),
+                                  QString::fromStdString (prop->get_name ()));
+
+    if (role != Qt::DisplayRole && role != Qt::EditRole)
+      return QVariant{};
+
+    switch (index.column ())
+      {
+      // case COL_NAME:
+      //   return QString::fromStdString (prop->get_name ());
+      case COL_VALUE:
+        return property_display_data (prop, m_oct_qobj);
+      case COL_TYPE:
+        return property_type_string (prop);
+      case COL_DOCLINK:
+        {
+          QVariant val;
+          val.setValue (hyperlink (
+              go_property_doc_url (QString::fromStdString (m_go.type ()),
+                                   QString::fromStdString (prop->get_name ())),
+              "?"));
+          return val;
+        }
+      default:
+        return QVariant{};
+      }
+  }
+
+  bool go_properties_table_model::setData (const QModelIndex &index,
+                                           const QVariant &value, int role)
+  {
+    if (index.column () != COL_VALUE)
+      return false;
+    if (role != Qt::EditRole)
+      return false;
+    if (index.row () < 0 || index.row () >= rowCount ())
+      return false;
+
+    auto *prop = static_cast<base_property *> (index.internalPointer ());
+    if (!prop)
+      return false;
+
+    bool res = false;
+
+    const auto typ = static_cast<QMetaType::Type> (value.type ());
+
+    if (typ == QMetaType::Double)
+      res = prop->set (octave_value (value.toDouble ()));
+
+    else if (typ == QMetaType::QString)
+      res = prop->set (octave_value (value.toString ().toStdString ()));
+
+    else if (typ == QMetaType::QByteArray)
+      {
+        auto ba = value.toByteArray ();
+        QDataStream ds (ba);
+        qint64 rows = 0, cols = 0;
+        ds >> rows >> cols;
+        if (ds.status () != QDataStream::Ok)
+          return false;
+
+        Matrix matrix (rows, cols);
+
+        for (octave_idx_type r = 0; r < rows; ++r)
+          {
+            for (octave_idx_type c = 0; c < cols; ++c)
+              {
+                double val = 0;
+                ds >> val;
+                if (ds.status () != QDataStream::Ok)
+                  return false;
+                matrix (r, c) = val;
+              }
+          }
+
+        res = prop->set (octave_value (matrix));
+      }
+
+    if (res)
+      emit dataChanged (index, index);
+
+    return res;
+  }
+
+  void go_properties_table_model::handle_go_update (const graphics_object &go,
+                                                    int prop_id)
+  {
+    if (go.get_handle () != m_go.get_handle ())
+      return;
+
+    auto prop = std::find_if (
+        m_props.begin (), m_props.end (),
+        [=] (const prop_index &pi) { return pi.id == prop_id; });
+
+    if (prop == m_props.end ())
+      return;
+
+    const auto row = static_cast<int> (prop - m_props.begin ());
+
+    const auto topLeft = index (row, COL_VALUE, QModelIndex{});
+    const auto bottomRight = index (row, COL_TYPE, QModelIndex{});
+
+    emit dataChanged (topLeft, bottomRight);
+  }
+
+  go_properties_item_delegate::go_properties_item_delegate (
+      QObject *p, base_qobject &oct_qobj, QTableView *view,
+      item_hyperlink_delegate *hl_dg, const gui_settings *settings)
+      : QStyledItemDelegate (p),
+        m_oct_qobj (oct_qobj), m_view{ view }, m_hl_dg{ hl_dg }
+  {
+    m_default_row_height = settings->value (pi_table_row_height).toInt ();
+    QObject::connect (this, &go_properties_item_delegate::layoutWillChange,
+                      m_view, &QTableView::resizeRowToContents,
+                      Qt::QueuedConnection);
+  }
+
+  void
+  go_properties_item_delegate::notice_settings (const gui_settings *settings)
+  {
+    m_default_row_height = settings->value (pi_table_row_height).toInt ();
+  }
+
+  inline int color_int_comp (const double comp)
+  {
+    return static_cast<int> (
+        std::round (255 * std::min (1.0, std::max (0.0, comp))));
+  }
+
+  inline QColor color_from_doubles (const double r, const double g,
+                                    const double b)
+  {
+    return QColor{ color_int_comp (r), color_int_comp (g),
+                   color_int_comp (b) };
+  }
+
+  constexpr int color_cell_vpadding = 3;
+  constexpr int color_cell_hpadding = 6;
+  constexpr int color_cell_spacing = 6;
+  constexpr int color_cell_icon_width = 30;
+  constexpr int color_cell_icon_height = 15;
+
+  static void paint_color (QPainter *painter,
+                           const QStyleOptionViewItem &option,
+                           const color_property *prop)
+  {
+    if (prop->is_rgb ())
+      {
+        auto m = prop->rgb ();
+        if (m.cols () != 3)
+          return;
+
+        painter->save ();
+
+        int dy = (option.rect.height () - color_cell_icon_height) / 2;
+
+        QRect iconRect
+            = option.rect.adjusted (color_cell_hpadding, dy, 0, -dy);
+        iconRect.setWidth (color_cell_icon_width);
+
+        const auto color = color_from_doubles (m (0, 0), m (0, 1), m (0, 2));
+
+        painter->setBrush (QBrush (color));
+        painter->fillRect (iconRect, Qt::SolidPattern);
+        painter->setPen (QPen (color.darker ()));
+        painter->drawRect (iconRect);
+
+        painter->restore ();
+
+        const auto text = array_display_string (m);
+        QRect textBoundingRect = option.fontMetrics.boundingRect (text);
+
+        dy = (option.rect.height () - textBoundingRect.height ()) / 2;
+
+        const auto textRect = option.rect.adjusted (
+            color_cell_hpadding + color_cell_spacing + color_cell_icon_width,
+            dy, -color_cell_hpadding, -dy);
+
+        const auto role = option.state.testFlag (QStyle::State_Selected)
+                              ? QPalette::HighlightedText
+                              : QPalette::NoRole;
+
+        QApplication::style ()->drawItemText (
+            painter, textRect, Qt::AlignLeft | Qt::AlignVCenter,
+            option.palette, true, text, role);
+      }
+  }
+
+  constexpr int hpadding = 3;
+
+  void go_properties_item_delegate::paint (QPainter *painter,
+                                           const QStyleOptionViewItem &option,
+                                           const QModelIndex &index) const
+  {
+    if (index.column () == COL_VALUE)
+      {
+        const auto *prop
+            = static_cast<base_property *> (index.internalPointer ());
+
+        if (prop->prop_type () == PROP_COLOR)
+          {
+            const auto *cp = static_cast<const color_property *> (prop);
+            if (cp->is_rgb ())
+              {
+                paint_color (painter, option, cp);
+                return;
+              }
+          }
+        else if (specific_matrix_item (prop))
+          {
+            QLocale loc;
+
+            const auto matrix = prop->get ().matrix_value ();
+            const auto orig = option.rect.topLeft ();
+            const int h = option.rect.height () / matrix.rows ();
+            const int w = option.rect.width () / matrix.cols ();
+            const auto alignModel = index.data (Qt::TextAlignmentRole);
+            const auto align = alignModel.isValid () ? alignModel.toInt ()
+                                                     : Qt::AlignCenter;
+
+            for (int r = 0; r < matrix.rows (); r++)
+              {
+                for (int c = 0; c < matrix.cols (); c++)
+                  {
+                    const auto tl = orig + QPoint (w * c + hpadding, h * r);
+                    const auto rect = QRect (tl, QSize (w - 2 * hpadding, h));
+                    auto role = QPalette::NoRole;
+                    if (option.state.testFlag (QStyle::State_Selected))
+                      {
+                        role = QPalette::HighlightedText;
+                      }
+                    QApplication::style ()->drawItemText (
+                        painter, rect, align, option.palette, true,
+                        loc.toString (matrix (r, c)), role);
+                  }
+              }
+            painter->save ();
+            QPen pen (QColor (Qt::gray));
+            painter->setPen (pen);
+            for (int r = 1; r < matrix.rows (); r++)
+              {
+                painter->drawLine (
+                    QPoint (option.rect.left (), orig.y () + r * h),
+                    QPoint (option.rect.right (), orig.y () + r * h));
+              }
+            for (int c = 1; c < matrix.cols (); c++)
+              {
+                painter->drawLine (
+                    QPoint (orig.x () + c * w, option.rect.top ()),
+                    QPoint (orig.x () + c * w, option.rect.bottom ()));
+              }
+            painter->restore ();
+            return;
+          }
+      }
+    else if (index.column () == COL_DOCLINK)
+      {
+        return m_hl_dg->paint (painter, option, index);
+      }
+    return QStyledItemDelegate::paint (painter, option, index);
+  }
+
+  QSize
+  go_properties_item_delegate::sizeHint (const QStyleOptionViewItem &option,
+                                         const QModelIndex &index) const
+  {
+    const auto minRowH = m_default_row_height;
+
+    if (index.column () == COL_VALUE)
+      {
+        const auto *prop
+            = static_cast<base_property *> (index.internalPointer ());
+
+        if (prop->prop_type () == PROP_COLOR)
+          {
+            const auto *cp = static_cast<const color_property *> (prop);
+            if (cp->is_rgb ())
+              {
+                auto m = cp->rgb ();
+                auto text = array_display_string (m);
+                auto textRect = option.fontMetrics.boundingRect (text);
+                return QSize (2 * color_cell_hpadding + color_cell_spacing
+                                  + color_cell_icon_width + textRect.width (),
+                              2 * color_cell_vpadding + textRect.height ());
+              }
+          }
+        else if (specific_matrix_item (prop))
+          {
+            QLocale loc;
+            const auto matrix = prop->get ().matrix_value ();
+
+            // we draw all cells of the same size
+            int maxW = 0, maxH = 0;
+            for (int r = 0; r < matrix.rows (); ++r)
+              {
+                for (int c = 0; c < matrix.cols (); ++c)
+                  {
+                    const auto txt = loc.toString (matrix (r, c));
+                    const auto rct = option.fontMetrics.boundingRect (txt);
+                    maxW = std::max (maxW, rct.width ());
+                    maxH = std::max (maxH, rct.height ());
+                  }
+              }
+
+            maxW += 2 * hpadding;
+
+            return QSize (
+                maxW * matrix.cols (),
+                std::max (static_cast<int> (maxH * matrix.rows ()), minRowH));
+          }
+      }
+    else if (index.column () == COL_DOCLINK)
+      {
+        return m_hl_dg->size_hint (option, index);
+      }
+
+    auto sz = QStyledItemDelegate::sizeHint (option, index);
+    sz.setHeight (std::max (sz.height (), minRowH));
+    return sz;
+  }
+
+  // editing
+  QWidget *go_properties_item_delegate::createEditor (
+      QWidget *parent, const QStyleOptionViewItem &option,
+      const QModelIndex &index) const
+  {
+    if (index.column () == COL_VALUE)
+      {
+        const auto *prop
+            = static_cast<base_property *> (index.internalPointer ());
+
+        if (prop->prop_type () == PROP_COLOR)
+          {
+            // Color editor is quite big. it need to fit in at least three rows
+
+            auto *editor = new color_editor_widget (
+                parent, static_cast<const color_property *> (prop));
+
+            resize_editor_cell (editor, index);
+
+            return editor;
+          }
+
+        if (specific_matrix_item (prop))
+          {
+            return new matrix_widget (parent, prop->get ().matrix_value ());
+          }
+
+        if (prop->is_radio ())
+          {
+            QComboBox *w = new QComboBox (parent);
+            const auto cell = prop->values_as_cell ();
+            const auto strvec = cell.string_vector_value ();
+            for (int i = 0; i < strvec.numel (); ++i)
+              {
+                const auto s = strvec.xelem (i);
+                w->addItem (QString::fromStdString (s));
+              }
+            w->setCurrentText (
+                QString::fromStdString (prop->get ().string_value ()));
+            return w;
+          }
+      }
+    return QStyledItemDelegate::createEditor (parent, option, index);
+  }
+
+  void go_properties_item_delegate::resize_editor_cell (
+      QWidget *editor, const QModelIndex &index) const
+  {
+    const auto sz = editor->sizeHint ();
+    m_former_size
+        = QSize (m_view->horizontalHeader ()->sectionSize (index.column ()),
+                 m_view->verticalHeader ()->sectionSize (index.row ()));
+
+    if (sz.width () > m_former_size.width ())
+      {
+        m_view->horizontalHeader ()->resizeSection (index.column (),
+                                                    sz.width ());
+      }
+    if (sz.height () > m_former_size.height ())
+      {
+        m_view->verticalHeader ()->resizeSection (index.row (), sz.height ());
+      }
+  }
+
+  void
+  go_properties_item_delegate::destroyEditor (QWidget *editor,
+                                              const QModelIndex &index) const
+  {
+    if (m_former_size.isValid ())
+      {
+        m_view->horizontalHeader ()->resizeSection (index.column (),
+                                                    m_former_size.width ());
+        m_view->verticalHeader ()->resizeSection (index.row (),
+                                                  m_former_size.height ());
+        m_former_size = QSize{};
+      }
+
+    QStyledItemDelegate::destroyEditor (editor, index);
+  }
+
+  void
+  go_properties_item_delegate::setEditorData (QWidget *editor,
+                                              const QModelIndex &index) const
+  {
+    if (index.column () == COL_VALUE)
+      {
+        const auto *prop
+            = static_cast<base_property *> (index.internalPointer ());
+
+        auto *combo = dynamic_cast<QComboBox *> (editor);
+        if (combo)
+          {
+            combo->setCurrentText (
+                QString::fromStdString (prop->get ().string_value ()));
+            return;
+          }
+
+        auto *cw = dynamic_cast<color_editor_widget *> (editor);
+        if (cw)
+          {
+            const auto ov = prop->get ();
+            if (ov.isnumeric ())
+              {
+                cw->set (color_editor_val (ov.matrix_value ()));
+              }
+            else
+              {
+                cw->set (color_editor_val (ov.string_value ()));
+              }
+            return;
+          }
+        auto *mw = dynamic_cast<matrix_widget *> (editor);
+        if (mw)
+          {
+            mw->set (prop->get ().matrix_value ());
+            return;
+          }
+      }
+    QStyledItemDelegate::setEditorData (editor, index);
+  }
+
+  static QByteArray matrix_byte_array (const Matrix &mat)
+  {
+    QByteArray ba;
+    {
+      QDataStream ds (&ba, QIODevice::WriteOnly);
+      qint64 rows = mat.rows ();
+      qint64 cols = mat.cols ();
+      ds << rows << cols;
+      for (octave_idx_type r = 0; r < mat.rows (); ++r)
+        {
+          for (octave_idx_type c = 0; c < mat.cols (); ++c)
+            {
+              double val = mat (r, c);
+              ds << val;
+            }
+        }
+    }
+    return ba;
+  }
+
+  void
+  go_properties_item_delegate::setModelData (QWidget *editor,
+                                             QAbstractItemModel *model,
+                                             const QModelIndex &index) const
+  {
+    if (index.column () == COL_VALUE)
+      {
+        // const auto *prop
+        //     = static_cast<base_property *> (index.internalPointer ());
+
+        QComboBox *w = dynamic_cast<QComboBox *> (editor);
+        if (w)
+          {
+            model->setData (index, w->currentText (), Qt::EditRole);
+            return;
+          }
+
+        auto *cw = dynamic_cast<color_editor_widget *> (editor);
+        if (cw)
+          {
+            const auto val = cw->get ();
+            switch (val.type ())
+              {
+              case color_editor_val::STR:
+                model->setData (index,
+                                QString::fromStdString (val.string_value ()),
+                                Qt::EditRole);
+                break;
+              case color_editor_val::RGB:
+                model->setData (index, matrix_byte_array (val.rgb_value ()),
+                                Qt::EditRole);
+              }
+            return;
+          }
+
+        auto *mw = dynamic_cast<matrix_widget *> (editor);
+        if (mw)
+          {
+            bool ok = false;
+            auto mat = mw->get (&ok);
+            if (!ok)
+              return;
+            model->setData (index, matrix_byte_array (mat), Qt::EditRole);
+          }
+      }
+    QStyledItemDelegate::setModelData (editor, model, index);
+  }
+
+  void go_properties_item_delegate::updateEditorGeometry (
+      QWidget *editor, const QStyleOptionViewItem &option,
+      const QModelIndex &index) const
+  {
+    QStyledItemDelegate::updateEditorGeometry (editor, option, index);
+  }
+
+  class numbers_only_key_filter : public QObject
+  {
+  public:
+    numbers_only_key_filter (QObject *p) : QObject (p) {}
+    virtual ~numbers_only_key_filter () {}
+
+  protected:
+    bool eventFilter (QObject *obj, QEvent *ev) override
+    {
+      if (ev->type () == QEvent::KeyPress || ev->type () == QEvent::KeyRelease)
+        {
+          auto *kev = static_cast<QKeyEvent *> (ev);
+          switch (kev->key ())
+            {
+            case Qt::Key_0:
+            case Qt::Key_1:
+            case Qt::Key_2:
+            case Qt::Key_3:
+            case Qt::Key_4:
+            case Qt::Key_5:
+            case Qt::Key_6:
+            case Qt::Key_7:
+            case Qt::Key_8:
+            case Qt::Key_9:
+            case Qt::Key_Period:
+            case Qt::Key_Comma:
+              break;
+            default:
+              return true;
+            }
+        }
+      return QObject::eventFilter (obj, ev);
+    }
+  };
+
+  matrix_widget::matrix_widget (QWidget *parent, const Matrix &matrix)
+      : QWidget (parent)
+  {
+    setAutoFillBackground (true);
+    setFocusPolicy (Qt::StrongFocus);
+
+    m_layout = new QGridLayout (this);
+    m_layout->setSpacing (0);
+    m_layout->setMargin (0);
+
+    auto *numbers_only = new numbers_only_key_filter (this);
+
+    QLocale loc;
+
+    for (int r = 0; r < static_cast<int> (matrix.rows ()); ++r)
+      {
+        for (int c = 0; c < static_cast<int> (matrix.cols ()); ++c)
+          {
+            const double val = matrix (r, c);
+            auto *edit = new QLineEdit (loc.toString (val), this);
+            edit->installEventFilter (numbers_only);
+            m_layout->addWidget (edit, r, c);
+          }
+      }
+  }
+
+  static double parseDouble (const QString &txt)
+  {
+    // we can't just use QLocale::toDouble as it will almost always fail.
+    // In fact it even fails to parse result of QLocale::toString.
+    // so we analyse the string a bit and convert to C locale before parsing.
+    // NaN is returned if parsing doesn't succeed.
+
+    QString C;
+
+    // step 1: remove all whitespace
+    std::copy_if (txt.begin (), txt.end (), std::back_inserter (C),
+                  [] (QChar c) { return !c.isSpace (); });
+
+    // step 2: remove separators (can be dot or comma) and normalize decimal
+    // separator (can also be dot or comma but would be the last one)
+    int dots = C.count ('.');
+    int lastDot = C.lastIndexOf ('.');
+    int commas = C.count (',');
+    int lastComma = C.lastIndexOf (',');
+
+    if (lastDot > lastComma)
+      {
+        // dot is decimal sep, comma (if any) are thousands sep
+        if (dots > 1)
+          {
+            return std::numeric_limits<double>::quiet_NaN ();
+          }
+        C.replace (",", "");
+      }
+    if (lastComma > lastDot)
+      {
+        // comma is decimal sep, dot (if any) are thousands sep
+        if (commas > 1)
+          {
+            return std::numeric_limits<double>::quiet_NaN ();
+          }
+        C.replace (".", "");
+        C.replace (",", ".");
+      }
+
+    bool ok = false;
+    const auto val = C.toDouble (&ok);
+    return ok ? val : std::numeric_limits<double>::quiet_NaN ();
+  }
+
+  Matrix matrix_widget::get (bool *ok) const
+  {
+    Matrix matrix (m_layout->rowCount (), m_layout->columnCount ());
+
+    for (int r = 0; r < static_cast<int> (matrix.rows ()); ++r)
+      {
+        for (int c = 0; c < static_cast<int> (matrix.cols ()); ++c)
+          {
+            auto *item = m_layout->itemAtPosition (r, c);
+            auto *edit
+                = item ? dynamic_cast<QLineEdit *> (item->widget ()) : nullptr;
+            if (!edit)
+              {
+                if (ok)
+                  *ok = false;
+                return matrix;
+              }
+            const double val = parseDouble (edit->text ());
+            if (val != val)
+              {
+                // NaN
+                if (ok)
+                  *ok = false;
+                return matrix;
+              }
+            matrix (r, c) = val;
+          }
+      }
+    if (ok)
+      *ok = true;
+    return matrix;
+  }
+
+  void matrix_widget::set (const Matrix &matrix)
+  {
+    if (matrix.rows () != m_layout->rowCount ()
+        || matrix.cols () != m_layout->columnCount ())
+      return;
+
+    QLocale loc;
+
+    for (int r = 0; r < static_cast<int> (matrix.rows ()); ++r)
+      {
+        for (int c = 0; c < static_cast<int> (matrix.cols ()); ++c)
+          {
+            auto *edit
+                = dynamic_cast<QLineEdit *> (m_layout->itemAtPosition (r, c));
+            if (!edit)
+              continue;
+            edit->setText (loc.toString (matrix (r, c)));
+          }
+      }
+  }
+
+  color_editor_val::color_editor_val (const std::string &str)
+      : m_type{ STR }, m_str{ str }
+  {
+  }
+
+  color_editor_val::color_editor_val (const Matrix &rgb)
+      : m_type{ RGB }, m_rgb{ rgb }
+  {
+  }
+
+  std::string color_editor_val::string_value () const
+  {
+    if (m_type != STR)
+      {
+        throw std::logic_error{ "color_editor_val: not a string" };
+      }
+    return m_str;
+  }
+
+  Matrix color_editor_val::rgb_value () const
+  {
+    if (m_type != RGB)
+      {
+        throw std::logic_error{ "color_editor_val: not RGB" };
+      }
+    return m_rgb;
+  }
+
+  // return #RRGGBB
+  static QString color_web_code (const QColor &color)
+  {
+    char buf[64];
+    if (std::snprintf (buf, 64, "#%02X%02X%02X", color.red (), color.green (),
+                       color.blue ())
+        == 7)
+      {
+        buf[7] = '\0';
+        return QString (buf);
+      }
+
+    return QString{};
+  }
+
+  constexpr auto default_icon_sz = QSize{ 35, 23 };
+
+  static QPixmap color_pixmap (QColor color, QSize size = default_icon_sz)
+  {
+    QPixmap pm{ size };
+    {
+      QPainter painter{ &pm };
+      QRect r{ QPoint{ 0, 0 }, size };
+      painter.setBrush (QBrush{ color });
+      painter.fillRect (r, Qt::SolidPattern);
+      painter.setPen (QPen{ color.darker () });
+      painter.drawRect (r);
+    }
+    return pm;
+  }
+
+  static QIcon color_icon (QColor color, QSize size = default_icon_sz)
+  {
+    auto pm = color_pixmap (color, size);
+    return QIcon{ pm };
+  }
+
+  struct color_entry
+  {
+    QString name;     // e.g. "aliceblue" or "red"
+    QString web_code; // #RRGGBB
+    QColor color;
+    QIcon icon; // for the drop down list
+  };
+
+  static std::vector<QString> svg_color_names ();
+
+  static const std::vector<color_entry> &svg_colors ()
+  {
+    static std::vector<color_entry> result;
+    if (result.size () == 0)
+      {
+        const auto names = svg_color_names ();
+        result.reserve (names.size ());
+        for (const auto &name : names)
+          {
+            const auto color = QColor (name);
+            const auto web_code = color_web_code (color);
+            const auto icon = color_icon (color);
+            result.push_back (color_entry{ name, web_code, color, icon });
+          }
+      }
+    return result;
+  }
+
+  static const std::vector<color_entry> &octave_colors ()
+  {
+    static std::vector<color_entry> result;
+    if (result.size () == 0)
+      {
+        const auto src = std::vector<std::pair<QString, QString>>{
+          { "blue", "#0000FF" },    { "black", "#000000" },
+          { "cyan", "#00FFFF" },    { "green", "#00FF00" },
+          { "magenta", "#FF00FF" }, { "red", "#FF0000" },
+          { "white", "#FFFFFF" },   { "yellow", "#FFFF00" },
+        };
+
+        result.reserve (src.size ());
+        for (const auto &pair : src)
+          {
+            const auto color = QColor (pair.second);
+            const auto icon = color_icon (color);
+            result.push_back (
+                color_entry{ pair.first, pair.second, color, icon });
+          }
+      }
+    return result;
+  }
+
+  // functor for std::find_if
+  struct by_web_code
+  {
+    QString web_code;
+
+    by_web_code (const QString &wc) : web_code{ wc.toUpper () } {}
+
+    bool operator() (const color_entry &entry) const
+    {
+      return entry.web_code == web_code;
+    }
+  };
+
+  color_editor_widget::color_editor_widget (QWidget *parent,
+                                            const color_property *prop)
+      : QWidget{ parent }, ui{ new Ui_color_editor_widget }
+  {
+    ui->setupUi (this);
+    // need to setup a button group because parent widget is not the same
+    auto *grp = new QButtonGroup (this);
+    grp->addButton (ui->radioRad);
+    grp->addButton (ui->rgbValRad);
+    grp->setExclusive (true);
+
+    setAutoFillBackground (true);
+    setFocusPolicy (Qt::StrongFocus);
+
+    auto cell = prop->values_as_cell ();
+    const auto strvec = cell.string_vector_value ();
+    for (int i = 0; i < strvec.numel (); ++i)
+      {
+        const auto s = strvec.xelem (i);
+        ui->radioBox->addItem (QString::fromStdString (s));
+      }
+
+    // if property do not have any radio value, then it only accepts RGB values
+    if (strvec.numel () == 0 && prop->is_rgb ())
+      {
+        ui->radioWgt->setVisible (false);
+        ui->line->setVisible (false);
+        ui->rgbValRad->setVisible (false);
+      }
+
+    ui->octaveBox->addItem ("");
+    for (const auto &col : octave_colors ())
+      {
+        ui->octaveBox->addItem (col.icon, col.name, col.web_code);
+      }
+
+    for (const auto &col : svg_colors ())
+      {
+        ui->svgBox->addItem (col.icon, col.name, col.web_code);
+      }
+
+    if (prop->is_rgb ())
+      {
+        const auto m = prop->rgb ();
+        if (m.rows () != 1 || m.cols () != 3)
+          {
+            throw std::logic_error{ "unconsistent color value" };
+          }
+        const auto col = color_from_doubles (m (0, 0), m (0, 1), m (0, 2));
+        set_rgb (col);
+      }
+    else
+      {
+        ui->radioBox->setCurrentText (
+            QString::fromStdString (prop->current_value ()));
+        set_rgb (QColor ("black"));
+      }
+
+    ui->radioRad->setChecked (prop->is_radio ());
+    ui->radioBox->setEnabled (prop->is_radio ());
+    ui->rgbValRad->setChecked (prop->is_rgb ());
+    ui->rgbWgt1->setEnabled (prop->is_rgb ());
+    ui->rgbWgt2->setEnabled (prop->is_rgb ());
+
+    QObject::connect (ui->radioRad, &QRadioButton::toggled, ui->radioBox,
+                      &QWidget::setEnabled);
+    QObject::connect (ui->rgbValRad, &QRadioButton::toggled, ui->rgbWgt1,
+                      &QWidget::setEnabled);
+    QObject::connect (ui->rgbValRad, &QRadioButton::toggled, ui->rgbWgt2,
+                      &QWidget::setEnabled);
+
+    QObject::connect (ui->rSpn,
+                      QOverload<double>::of (&QDoubleSpinBox::valueChanged),
+                      this, &color_editor_widget::handle_rgb_mat_change);
+    QObject::connect (ui->gSpn,
+                      QOverload<double>::of (&QDoubleSpinBox::valueChanged),
+                      this, &color_editor_widget::handle_rgb_mat_change);
+    QObject::connect (ui->bSpn,
+                      QOverload<double>::of (&QDoubleSpinBox::valueChanged),
+                      this, &color_editor_widget::handle_rgb_mat_change);
+
+    QObject::connect (
+        ui->octaveBox, QOverload<int>::of (&QComboBox::currentIndexChanged),
+        this, &color_editor_widget::handle_rgb_octave_color_change);
+
+    QObject::connect (ui->svgBox, &QComboBox::currentTextChanged, this,
+                      &color_editor_widget::handle_rgb_svg_change);
+
+    QObject::connect (ui->pickBtn, &QPushButton::clicked, this,
+                      &color_editor_widget::handle_rgb_pick);
+  }
+
+  color_editor_widget::~color_editor_widget () { delete ui; }
+
+  void color_editor_widget::set (const color_editor_val &val)
+  {
+    switch (val.type ())
+      {
+      case color_editor_val::STR:
+        ui->radioRad->setChecked (true);
+        ui->radioBox->setCurrentText (
+            QString::fromStdString (val.string_value ()));
+        break;
+      case color_editor_val::RGB:
+        ui->rgbValRad->setChecked (true);
+        const auto m = val.rgb_value ();
+        if (m.cols () != 3)
+          {
+            throw std::logic_error{ "inconsistent color matrix" };
+          }
+        set_rgb (color_from_doubles (m (0, 0), m (0, 1), m (0, 2)));
+        break;
+      }
+  }
+
+  color_editor_val color_editor_widget::get () const
+  {
+    if (ui->radioRad->isChecked ())
+      {
+        return color_editor_val (ui->radioBox->currentText ().toStdString ());
+      }
+    else if (ui->rgbValRad->isChecked ())
+      {
+        auto m = Matrix (1, 3);
+        m (0, 0) = ui->rSpn->value ();
+        m (0, 1) = ui->gSpn->value ();
+        m (0, 2) = ui->bSpn->value ();
+        return color_editor_val (m);
+      }
+    return color_editor_val ("");
+  }
+
+  void color_editor_widget::set_rgb (const QColor &color, rgb_source source)
+  {
+    if (source != rgb_source::spinbox)
+      {
+        ui->rSpn->setValue (color.redF ());
+        ui->gSpn->setValue (color.greenF ());
+        ui->bSpn->setValue (color.blueF ());
+      }
+
+    const auto web_code = color_web_code (color);
+
+    if (source != rgb_source::octave)
+      {
+        const auto &oct_cols = octave_colors ();
+        auto oct_it = std::find_if (oct_cols.begin (), oct_cols.end (),
+                                    by_web_code{ web_code });
+        if (oct_it != oct_cols.end ())
+          {
+            ui->octaveBox->setCurrentIndex (
+                static_cast<int> (oct_it - oct_cols.begin ()) + 1);
+          }
+        else
+          {
+            ui->octaveBox->setCurrentIndex (0);
+          }
+      }
+
+    if (source != rgb_source::svg)
+      {
+        const auto &svg_cols = svg_colors ();
+        auto svg_it = std::find_if (svg_cols.begin (), svg_cols.end (),
+                                    by_web_code{ web_code });
+        if (svg_it != svg_cols.end ())
+          {
+            ui->svgBox->setCurrentIndex (
+                static_cast<int> (svg_it - svg_cols.begin ()));
+          }
+        else
+          {
+            ui->svgBox->setCurrentText (color_web_code (color));
+          }
+      }
+
+    const auto sz = ui->rgbIcon->size () - QSize (8, 8);
+    auto pixmap = color_pixmap (color, sz);
+    ui->rgbIcon->setPixmap (pixmap);
+  }
+
+  void color_editor_widget::handle_rgb_mat_change ()
+  {
+    const auto color = color_from_doubles (
+        ui->rSpn->value (), ui->gSpn->value (), ui->bSpn->value ());
+    set_rgb (color, rgb_source::spinbox);
+  }
+
+  void color_editor_widget::handle_rgb_octave_color_change ()
+  {
+    if (ui->octaveBox->currentIndex () <= 0)
+      return;
+
+    const auto &oct_cols = octave_colors ();
+
+    set_rgb (oct_cols[ui->octaveBox->currentIndex () - 1].color,
+             rgb_source::octave);
+  }
+
+  void color_editor_widget::handle_rgb_svg_change ()
+  {
+    // this is an editable combo box, the user may enter web code value, or
+    // svg name directly. If string is not a valid color, indicate by
+    // displaying red text
+
+    const auto value = ui->svgBox->currentText ();
+
+    const auto col = QColor (value);
+    auto *edit = ui->svgBox->lineEdit ();
+    auto palette = edit->palette ();
+    // discriminate #RGB web code (only accept #RRGGBB)
+    if (!col.isValid () || (value.startsWith ('#') && value.size () != 7))
+      {
+        palette.setColor (QPalette::Text, QColor ("red"));
+      }
+    else
+      {
+        set_rgb (col, rgb_source::svg);
+        palette.setColor (QPalette::Text, QColor ("black"));
+      }
+    edit->setPalette (palette);
+  }
+
+  void color_editor_widget::handle_rgb_pick ()
+  {
+    auto val = get ();
+    QColor c;
+    if (ui->rgbValRad->isChecked ())
+      {
+        c = color_from_doubles (ui->rSpn->value (), ui->gSpn->value (),
+                                ui->bSpn->value ());
+      }
+    QColorDialog dlg (c, this);
+    dlg.setOption (QColorDialog::ShowAlphaChannel, false);
+    if (dlg.exec () == QColorDialog::Accepted)
+      {
+        set_rgb (dlg.currentColor ());
+      }
+  }
+
+  static std::vector<QString> svg_color_names ()
+  {
+    return std::vector<QString>{ "aliceblue",
+                                 "antiquewhite",
+                                 "aqua",
+                                 "aquamarine",
+                                 "azure",
+                                 "beige",
+                                 "bisque",
+                                 "black",
+                                 "blanchedalmond",
+                                 "blue",
+                                 "blueviolet",
+                                 "brown",
+                                 "burlywood",
+                                 "cadetblue",
+                                 "chartreuse",
+                                 "chocolate",
+                                 "coral",
+                                 "cornflowerblue",
+                                 "cornsilk",
+                                 "crimson",
+                                 "cyan",
+                                 "darkblue",
+                                 "darkcyan",
+                                 "darkgoldenrod",
+                                 "darkgray",
+                                 "darkgreen",
+                                 "darkgrey",
+                                 "darkkhaki",
+                                 "darkmagenta",
+                                 "darkolivegreen",
+                                 "darkorange",
+                                 "darkorchid",
+                                 "darkred",
+                                 "darksalmon",
+                                 "darkseagreen",
+                                 "darkslateblue",
+                                 "darkslategray",
+                                 "darkslategrey",
+                                 "darkturquoise",
+                                 "darkviolet",
+                                 "deeppink",
+                                 "deepskyblue",
+                                 "dimgray",
+                                 "dimgrey",
+                                 "dodgerblue",
+                                 "firebrick",
+                                 "floralwhite",
+                                 "forestgreen",
+                                 "fuchsia",
+                                 "gainsboro",
+                                 "ghostwhite",
+                                 "gold",
+                                 "goldenrod",
+                                 "gray",
+                                 "grey",
+                                 "green",
+                                 "greenyellow",
+                                 "honeydew",
+                                 "hotpink",
+                                 "indianred",
+                                 "indigo",
+                                 "ivory",
+                                 "khaki",
+                                 "lavender",
+                                 "lavenderblush",
+                                 "lawngreen",
+                                 "lemonchiffon",
+                                 "lightblue",
+                                 "lightcoral",
+                                 "lightcyan",
+                                 "lightgoldenrodyellow",
+                                 "lightgray",
+                                 "lightgreen",
+                                 "lightgrey",
+                                 "lightpink",
+                                 "lightsalmon",
+                                 "lightseagreen",
+                                 "lightskyblue",
+                                 "lightslategray",
+                                 "lightslategrey",
+                                 "lightsteelblue",
+                                 "lightyellow",
+                                 "lime",
+                                 "limegreen",
+                                 "linen",
+                                 "magenta",
+                                 "maroon",
+                                 "mediumaquamarine",
+                                 "mediumblue",
+                                 "mediumorchid",
+                                 "mediumpurple",
+                                 "mediumseagreen",
+                                 "mediumslateblue",
+                                 "mediumspringgreen",
+                                 "mediumturquoise",
+                                 "mediumvioletred",
+                                 "midnightblue",
+                                 "mintcream",
+                                 "mistyrose",
+                                 "moccasin",
+                                 "navajowhite",
+                                 "navy",
+                                 "oldlace",
+                                 "olive",
+                                 "olivedrab",
+                                 "orange",
+                                 "orangered",
+                                 "orchid",
+                                 "palegoldenrod",
+                                 "palegreen",
+                                 "paleturquoise",
+                                 "palevioletred",
+                                 "papayawhip",
+                                 "peachpuff",
+                                 "peru",
+                                 "pink",
+                                 "plum",
+                                 "powderblue",
+                                 "purple",
+                                 "red",
+                                 "rosybrown",
+                                 "royalblue",
+                                 "saddlebrown",
+                                 "salmon",
+                                 "sandybrown",
+                                 "seagreen",
+                                 "seashell",
+                                 "sienna",
+                                 "silver",
+                                 "skyblue",
+                                 "slateblue",
+                                 "slategray",
+                                 "slategrey",
+                                 "snow",
+                                 "springgreen",
+                                 "steelblue",
+                                 "tan",
+                                 "teal",
+                                 "thistle",
+                                 "tomato",
+                                 "turquoise",
+                                 "violet",
+                                 "wheat",
+                                 "white",
+                                 "whitesmoke",
+                                 "yellow",
+                                 "yellowgreen" };
+  }
+}
